#include "stdafx.h"
#include "hklm.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CWinApp theApp;

int _tmain(int /*argc*/, TCHAR* /*argv[]*/, TCHAR* /*envp[]*/)
{
	int nRetCode = 0;
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		_tprintf(_T("Fatal Error: MFC initialization failed\n"));
		nRetCode = 1;
	}
	else
	{
		CHKLM hklm;

    //Set the name of the Company
		hklm.SetRegistryKey(_T("PJ Naughter"));
		hklm.SetRegistryKey(IDS_PJ_NAUGHTER);

    //Test the string persistance functions
		BOOL bSuccess = hklm.WriteProfileString(_T("Test Section"), _T("Test String"), _T("Test string value"));
	  CString sString = hklm.GetProfileString(_T("Test Section"), _T("Dummy Test String"));
		sString = hklm.GetProfileString(_T("Test Section"), _T("Test String"));

		//Test the integer persistance functions
		bSuccess = hklm.WriteProfileInt(_T("Test Section"), _T("Test Int"), 33);
		UINT nValue = hklm.GetProfileInt(_T("Test Section"), _T("Dummy Test Int"), 0);
		nValue = hklm.GetProfileInt(_T("Test Section"), _T("Test Int"), 0);

		//Test the blob persistance functions
		char* pData = "1234567890";
		bSuccess = hklm.WriteProfileBinary(_T("Test Section"), _T("Test Blob"), (LPBYTE) pData, strlen(pData));
    LPBYTE pRetrievedData;
		UINT nBytes;
		bSuccess = hklm.GetProfileBinary(_T("Test Section"), _T("Unknown Test Blob"), &pRetrievedData, &nBytes);
		bSuccess = hklm.GetProfileBinary(_T("Test Section"), _T("Test Blob"), &pRetrievedData, &nBytes);
		delete [] pRetrievedData;
	}

	return nRetCode;
}




